//	KaledioTileOptions.c
//
//	© 2010 by Jeff Weeks
//	See TermsOfUse.txt

#include "KaleidoTile-Common.h"


void SetPositiveImagesFlag(
	ModelData	*md,
	bool		aPositiveImagesFlag)
{
	md->itsPositiveImagesFlag = aPositiveImagesFlag;
	md->itsRedrawRequestFlag = true;
}

void SetNegativeImagesFlag(
	ModelData	*md,
	bool		aNegativeImagesFlag)
{
	md->itsNegativeImagesFlag = aNegativeImagesFlag;
	md->itsRedrawRequestFlag = true;
}

void SetMirrorLinesFlag(
	ModelData	*md,
	bool		aMirrorLinesFlag)
{
	md->itsMirrorLinesFlag = aMirrorLinesFlag;
	md->itsRedrawRequestFlag = true;
}

void SetBiggerTiles(
	ModelData	*md)
{
	SetUpTiling(	&md->itsTiling,
					md->itsTiling.itsPQR[0],
					md->itsTiling.itsPQR[1],
					md->itsTiling.itsPQR[2],
					md->itsTiling.itsEuclideanZoom + 1);
	
	PlayWAV("rising.wav");

	md->itsRedrawRequestFlag = true;
}

void SetSmallerTiles(
	ModelData	*md)
{
	SetUpTiling(	&md->itsTiling,
					md->itsTiling.itsPQR[0],
					md->itsTiling.itsPQR[1],
					md->itsTiling.itsPQR[2],
					md->itsTiling.itsEuclideanZoom - 1);
	
	PlayWAV("falling.wav");

	md->itsRedrawRequestFlag = true;
}

void SetMultisamplingEnabledFlag(
	ModelData	*md,
	bool		aMultisamplingEnabledFlag)
{
	//	The platform-dependent code will replace the old OpenGL context with a new one.
	//	Here we merely set and save the platform-independent code's flag.
	
	md->itsMultisamplingEnabledFlag	= aMultisamplingEnabledFlag;
	md->itsRedrawRequestFlag		= true;

	SetUserPrefBool("multisampling", aMultisamplingEnabledFlag);
}

void SetStereo3DMode(
	ModelData	*md,
	StereoMode	aStereo3DMode)
{
	md->itsStereoMode			= aStereo3DMode;
	md->itsPreparedTextures		= false;
	md->itsRedrawRequestFlag	= true;
}

void SetMeshSize(
	ModelData		*md,
	unsigned int	aMeshSize)
{
	if (aMeshSize <  2)
		aMeshSize =  2;
	if (aMeshSize > 16)
		aMeshSize = 16;

	md->itsMeshSize = aMeshSize;

	md->itsRedrawRequestFlag = true;
}

void SetHyperbolicTilingRadius(
	ModelData	*md,
	double		aTilingRadius)
{
	if (aTilingRadius < 0.0)
		aTilingRadius = 0.0;
	if (aTilingRadius > 6.0)	//	could go a little larger, but it'll be slow
		aTilingRadius = 6.0;

	md->itsHyperbolicTilingRadius = aTilingRadius;

	md->itsRedrawRequestFlag = true;
}

void SetAnisotropicEnabledFlag(
	ModelData	*md,
	bool		anAnisotropicEnabledFlag)
{
	md->itsAnisotropicEnabledFlag	= anAnisotropicEnabledFlag;
	md->itsPreparedTextures			= false;
	md->itsRedrawRequestFlag		= true;
}

void SetShadersEnabledFlag(
	ModelData	*md,
	bool		aShadersEnabledFlag)
{
	md->itsShadersEnabledFlag	= aShadersEnabledFlag;
	md->itsPreparedShaders		= false;
	md->itsRedrawRequestFlag	= true;

	SetUserPrefBool("shaders", aShadersEnabledFlag);
}
