//	KaleidoTileTiling.h

#pragma once

#include <stdbool.h>
#include "KaleidoTileMatrices.h"


//	What powers of √2 are acceptable as zoom factors in the Euclidean case?
#define MAX_EUCLIDEAN_ZOOM	+2
#define MIN_EUCLIDEAN_ZOOM	-4


typedef struct
{
	unsigned int	itsPQR[3];
	ktGeometry		itsGeometry;
	signed int		itsEuclideanZoom;	//	exponent of √2;  always present, but used only when itsGeometry == GeometryEuclidean
	double			itsInradius,
					itsDomainRadius;
	ktVector		itsVertices[3],
					itsBarycentricBasis[3];
	double			itsDomainScale,	//	for use in rendering single fundamental domain
					itsDomainOffset;
	ktMatrix		itsGenerators[3];
} ktTiling;


extern void	SetUpTiling(ktTiling *aTiling, unsigned int p, unsigned int q, unsigned int r, signed int aEuclideanZoom);
extern void	KeepNorthPoleCentered(ktMatrix aPosition, ktMatrix aGeneratorSet[3], ktGeometry aGeometry);
extern bool	TilingIs22n(ktTiling *aTiling);
